package com.shadeslider.project.controllers 
{
    import com.shadeslider.base.*;
    import com.shadeslider.project.consts.*;
    import com.shadeslider.project.events.*;
    import flash.events.*;
    import flash.net.*;
    
    public class MainController extends com.shadeslider.base.AbstractController
    {
        public function MainController(arg1:com.shadeslider.base.AbstractModel, arg2:com.shadeslider.base.ComponentView, arg3:Object)
        {
            super(arg1, arg2, arg3);
            model.addEventListener(com.shadeslider.base.ModelEvent.STATE, this.modelState);
            this.generateBlogCode();
            return;
        }

        protected override function initialize():void
        {
            this.reloadItems();
            return;
        }

        private function onItemsLoadedHandler(arg1:flash.events.Event):void
        {
            var loc1:*=new XML(arg1.target.data);
            var loc2:*=0;
            while (loc2 < loc1.Item.length()) 
            {
                model.items.push({"idx":model.items.length, "url":String(loc1.Item[loc2].Url), "name":String(loc1.Item[loc2].Name), "degree":String(loc1.Item[loc2].Degree)});
                loc2 = (loc2 + 1);
            }
            if (!model.APP_INITED)
            {
                model.APP_STATE = com.shadeslider.project.events.ApplicationStates.APP_INIT;
            }
            return;
        }

        private function reloadItems():void
        {
            this.itemTypesLoaded = 0;
            model.itemsHot = new Array();
            model.itemsWarm = new Array();
            model.itemsCold = new Array();
            this.loadItems(config.itemsBufferNum, com.shadeslider.project.consts.ItemType.ITEM_TYPE_HOT);
            this.loadItems(config.itemsBufferNum, com.shadeslider.project.consts.ItemType.ITEM_TYPE_WARM);
            this.loadItems(config.itemsBufferNum, com.shadeslider.project.consts.ItemType.ITEM_TYPE_COLD);
            return;
        }

        protected function modelState(arg1:com.shadeslider.base.ModelEvent=null):void
        {
            var loc1:*=model.APP_STATE;
            switch (loc1) 
            {
                case com.shadeslider.project.events.ApplicationStates.INIT_ITEMS_RELOAD:
                {
                    this.reloadItems();
                    break;
                }
            }
            return;
        }

        private function loadItems(arg1:int, arg2:String, arg3:int=0, arg4:Boolean=true):void
        {
            var lURLLoader:flash.net.URLLoader;
            var lURLRequest:flash.net.URLRequest;
            var lURLVariables:flash.net.URLVariables;
            var pDirDown:Boolean=true;
            var pItemType:String;
            var pQuantity:int;
            var pStartIdx:int=0;

            var loc1:*;
            pQuantity = arg1;
            pItemType = arg2;
            pStartIdx = arg3;
            pDirDown = arg4;
            lURLVariables = new flash.net.URLVariables();
            lURLVariables.type = pItemType;
            lURLVariables.start = pStartIdx;
            lURLVariables.quantity = pQuantity;
            lURLVariables.city = model.currentCityCode;
            lURLRequest = new flash.net.URLRequest(config.itemsUrl + "?" + Math.random());
            lURLRequest.data = lURLVariables;
            lURLRequest.method = flash.net.URLRequestMethod.POST;
            lURLLoader = new flash.net.URLLoader();
            lURLLoader.addEventListener(flash.events.Event.COMPLETE, function (arg1:flash.events.Event):void
            {
                var loc3:*=null;
                var loc1:*=new XML(arg1.target.data);
                var loc2:*=0;
                while (loc2 < loc1.Item.length()) 
                {
                    loc3 = {"url":String(loc1.Item[loc2].Url), "name":String(loc1.Item[loc2].Name), "degree":Math.ceil(Number(loc1.Item[loc2].Degree))};
                    var loc4:*=pItemType;
                    switch (loc4) 
                    {
                        case com.shadeslider.project.consts.ItemType.ITEM_TYPE_HOT:
                        {
                            loc3.idx = model.itemsHot.length;
                            model.itemsHot.push(loc3);
                            break;
                        }
                        case com.shadeslider.project.consts.ItemType.ITEM_TYPE_WARM:
                        {
                            loc3.idx = model.itemsWarm.length;
                            model.itemsWarm.push(loc3);
                            break;
                        }
                        case com.shadeslider.project.consts.ItemType.ITEM_TYPE_COLD:
                        {
                            loc3.idx = model.itemsCold.length;
                            model.itemsCold.push(loc3);
                            break;
                        }
                    }
                    loc2 = (loc2 + 1);
                }
                itemTypesLoaded++;
                if (itemTypesLoaded >= 3)
                {
                    model.APP_STATE = com.shadeslider.project.events.ApplicationStates.ITEMS_LOADED;
                    model.APP_STATE = com.shadeslider.project.events.ApplicationStates.END_MODAL;
                    if (!model.APP_INITED)
                    {
                        model.APP_STATE = com.shadeslider.project.events.ApplicationStates.APP_INIT;
                    }
                }
                return;
            })
            lURLLoader.load(lURLRequest);
            return;
        }

        private function generateBlogCode():void
        {
            model.blogCodeHTML = ["<object id=\"eclipseWidgetBig\" classid=\"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000\" name=\"eclipseWidgetBig\" width=\"" + view._stageClip.stage.stageWidth + "\" height=\"" + view._stageClip.stage.stageHeight + "\">", "\t" + "<param name=\"movie\" value=\"" + view._stageClip.root.loaderInfo.url + "\" />", "\t" + "<param name=\"allowfullscreen\" value=\"true\" />", "\t" + "<param name=\"allowscriptaccess\" value=\"always\" />", "\t" + "<embed", "\t\t" + "type=\"application/x-shockwave-flash\"", "\t\t" + "id=\"eclipseWidgetBig\"", "\t\t" + "name=\"eclipseWidgetBig\"", "\t\t" + "src=\"" + view._stageClip.root.loaderInfo.url + "\"", "\t\t" + "width=\"" + view._stageClip.stage.stageWidth + "\"", "\t\t" + "height=\"" + view._stageClip.stage.stageHeight + "\" ", "\t\t" + "allowscriptaccess=\"always\"", "\t\t" + "allowfullscreen=\"true\"", "\t" + "/>", "</object>"].join("\n");
            return;
        }

        protected override function addChildren():void
        {
            if (!config.bannerSmall)
            {
                addChild("toolbar", new com.shadeslider.project.controllers.ToolbarController(model, view.children.toolbar, config));
            }
            addChild("scrollerHot", new com.shadeslider.project.controllers.ScrollerController(model, view.children.scrollerHot, config, this, {"itemType":com.shadeslider.project.consts.ItemType.ITEM_TYPE_HOT}));
            addChild("scrollerWarm", new com.shadeslider.project.controllers.ScrollerController(model, view.children.scrollerWarm, config, this, {"itemType":com.shadeslider.project.consts.ItemType.ITEM_TYPE_HOT}));
            addChild("scrollerCold", new com.shadeslider.project.controllers.ScrollerController(model, view.children.scrollerCold, config, this, {"itemType":com.shadeslider.project.consts.ItemType.ITEM_TYPE_HOT}));
            return;
        }

        private var itemTypesLoaded:int=0;
    }
}
